SystemOrganization addCategory: #Rizel!
SystemOrganization addCategory: #'Rizel-Tests'!

TestCase subclass: #RizelBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tests'!

!RizelBrowserTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 16:33'!
testGlobalBrowser
	"Creational test"
	|browser|
	browser := RizelGlobalBrowser new.
	browser openOn: (RizelRunnerTest env).
	
! !

!RizelBrowserTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 16:33'!
testMethodBrowser
	"Creational test"
	|browser|
	browser := RizelMethodBrowser new.
	browser openOn: (RizelRunnerTest env).
	
! !

!RizelBrowserTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/7/2012 23:29'!
testStandarBrowser
	"Creational test"
	|browser|
	browser := RizelBrowser new.
	browser openOn: (RizelRunnerTest env).
	
! !

!RizelBrowserTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:24'!
testStandarBrowser2
	"Creational test"
	|browser|
	browser := RizelMethodBrowser new.
	browser openOn: (RizelRunnerTest env copyWithLast: 100).
	
! !

!RizelBrowserTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 02:01'!
testStandarBrowser3
	"Creational test"
	|browser|
	browser := RizelMethodBrowser new.
	browser openOn: (RizelRunnerTest env2).
	
! !

TestCase subclass: #RizelRunnerTest
	instanceVariableNames: ''
	classVariableNames: 'env env2'
	poolDictionaries: ''
	category: 'Rizel-Tests'!

!RizelRunnerTest class methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:07'!
env
	^ env.! !

!RizelRunnerTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:33'!
env2
	^ env2.! !

!RizelRunnerTest class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:33'!
env2:  aEnv
	env2:= aEnv.! !

!RizelRunnerTest class methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:06'!
env:  aEnv
	env:= aEnv.! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:31'!
historyDiagram
	| diag canvas|
	diag := ESDiagramRenderer new.
	(diag historyDiagram)
		dataset: #history;
		width: 500;
		height: 400;
		attribute: #yValue;
		regularAxis;
		horizontalLegend;
		color: #color;
		useColors: ESAbstractDiagram lightColors;
		models: self projects.
	diag interaction 
		strongHighlightWhenOver.
	canvas := diag open.
	canvas delete.! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 12/27/2011 23:24'!
mondrianDemo
	| view canvas|
	view := MOViewRenderer new.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
	view root applyLayout.! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 19:29'!
projects
	
	| dummies1 dummies2 dummies3 historyObject LOC1 LOC2 LOC3 combination LOC4 LOC5 LOC6 dummies4 dummies5 dummies6 |
	dummies1 := ESDummyFactory new.
	dummies2 := ESDummyFactory new.
	dummies3 := ESDummyFactory new.
	dummies4 := ESDummyFactory new.
	dummies5 := ESDummyFactory new.
	dummies6 := ESDummyFactory new.
	historyObject := ESDummyFactory new.
	LOC1 := #(1 2 3 4 5 6 7 8 10 10 10 10 10 10 10 10 7 8 10 10 10 12 13 13 14 19 10).
	LOC2 := #(13 12 11 10 10 11 12 12 12 14 9 10 11 12 11 16 15 14 13 16 15 14 10 10 15 20 30).
	LOC3 := #(16 15 14 13 12 15 15 16 18 19 18 10 11 11 12 13 14 12 10 5 3 2 1 1 0 0 0).
	LOC4 := #(1 1 1 2 3 4 4 4 4 3 4 2 3 4 3 5 8 15 19 20 14 15 18 12 14 13 14).
	LOC5 := #(13 12 11 10 10 11 16 15 14 12 10 10 12 13 14 14 19 21 22 23 24 25 35 40 45 50 60).
	LOC6 := #(1 2 3 4 2 3 3 2 2 3 2 1 2 3 4 2 1 5 6 8 10 12 13 15 12 12 12).
	dummies1 yValues: LOC1.
	dummies2 yValues: LOC2.
	dummies3 yValues: LOC3.
	dummies4 yValues: LOC4.
	dummies5 yValues: LOC5.
	dummies6 yValues: LOC6.
	combination := OrderedCollection new.
	combination add: dummies1 buildDummies.
	combination add: dummies2 buildDummies.
	combination add: dummies3 buildDummies.
	combination add: dummies4 buildDummies.
	combination add: dummies5 buildDummies.
	combination add: dummies6 buildDummies.
	historyObject colors: #('Alpha' 'Beta' 'Delta' 'Epsilon' 'Gamma' 'Zeta').
	historyObject histories: combination.
	^historyObject buildDummies! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/1/2012 18:06'!
testBasic
	|rep versions v80 runner prof|
	rep := MCHttpRepository location:'http://www.squeaksource.com/EyeSee'  user: '' password: ''.
	versions := ( (rep versionNamesBetween: 80 and: 85 every: 1) select:[:each | '*Core*' match: each]).
	v80 := versions first.
	runner := RizelVersionRunner repository: rep version: v80.
	prof := runner profile: [ ESExamples new historyDiagram3. ].
	prof inspect.! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 18:18'!
testEnviroment
	| versions env|
	versions := OrderedCollection new.
	versions add: ((Smalltalk at: #ConfigurationOfMondrian) project version: '2.9'); 
 			 add: ((Smalltalk at: #ConfigurationOfMondrian) project version: '2.1.2');
 			 add: ((Smalltalk at: #ConfigurationOfMondrian) project lastVersion).
	
	env := RizelEnviroment new.
	RizelRunnerTest env: env.
	versions do: [:version | 
			| runner rv|
			runner := RizelCompteurRunner new.
			runner	regexExp: 'Mondrian-*';
					configName: 'ConfigurationOfMondrian';
					configuration: version;
					projectName: 'Mondrian';
					version: version.
			"Transcript show:version."
			rv := runner profile: [ [ self mondrianDemo.] on: Error do:[  Transcript show:'Error'.]  ].
			env addVersion: rv ].
	^ env! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 00:05'!
testEnviroment2
	| versions env|
	versions := ((Smalltalk at: #ConfigurationOfMondrian) project versions) last: 100.
	
	env := RizelEnviroment new.
	RizelRunnerTest env: env.
	versions do: [:version | 
			| runner rv|
			[
			runner := RizelCompteurRunner new.
			runner	regexExp: 'Mondrian-*';
					configName: 'ConfigurationOfMondrian';
					configuration: version;
					projectName: 'Mondrian';
					version: version.
			"Transcript show:version."
			rv := runner profile: [ [ self mondrianDemo.] on: Error do:[  Transcript show:'Error'.]  ].
			env addVersion: rv.] on: Error do:[ Transcript show: '------Error-----';cr.]. ].
	^ env! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:39'!
testEnviroment3
	| versions env|
	versions := ((Smalltalk at: #ConfigurationOfMerlin) project versions).
	
	env := RizelEnviroment new.
	RizelRunnerTest env2: env.
	versions do: [:version | 
			| runner rv|
			[
			runner := RizelCompteurRunner new.
			runner	regexExp: 'Merlin-*';
					configName: 'ConfigurationOfMerlin';
					configuration: version;
					projectName: 'Merlin';
					version: version.
			"Transcript show:version."
			rv := runner profile: [ [ MerlinExamples usingCallbackAndRefresh.] on: Error do:[  Transcript show:'Error'.]  ].
			env addVersion: rv.] on: Error do:[ Transcript show: '------Error-----';cr.]. ].
	^ env! !

!RizelRunnerTest methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 18:24'!
testEnviromentHapao
	| versions env|
	versions := OrderedCollection new.
	versions add: ((Smalltalk at: #ConfigurationOfMondrian) project version: '2.9'); 
 			 add: ((Smalltalk at: #ConfigurationOfMondrian) project version: '2.1.2');
 			 add: ((Smalltalk at: #ConfigurationOfMondrian) project lastVersion).
	
	env := RizelEnviroment new.
	RizelRunnerTest env: env.
	versions do: [:version | 
			| runner rv|
			runner := RizelHapaoRunner new.
			runner	regexExp: 'Mondrian-*';
					configName: 'ConfigurationOfMondrian';
					configuration: version;
					projectName: 'Mondrian';
					version: version.
			"Transcript show:version."
			rv := runner profile: [ [ self mondrianDemo.] on: Error do:[  Transcript show:'Error'.]  ].
			env addVersion: rv ].
	^ env! !

Object subclass: #RizelBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/7/2012 23:15'!
browser
	""
	|browser|
	browser := GLMTabulator new.
	browser column: #eyesee.
	
	browser transmit
		to: #eyesee;
		from: #outer port: #entity;
		andShow:[ :a | self eyeseeOn: a ].
	
	^ browser.
	! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 00:02'!
eyeseeOn: presentation
	^ presentation eyesee
			when: [ :env | env notNil ];
			diagram: [ :renderer :env |
					| diag |
					diag := (renderer historyDiagram).
					diag
						dataset: #history;
						width: 500;
						height: 400;
						attribute: #yValue;
						regularAxis;
						horizontalLegend;
						color: #color;
						useColors: ESAbstractDiagram lightColors;
						models: (self histories: env).
					diag].! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 00:04'!
histories: env
	|hm dummies historyObject combination|
	historyObject := ESDummyFactory new.
	combination := OrderedCollection new.
	hm := self hotMethods: env.
	hm do: [ :m| 
		dummies := ESDummyFactory new.	
		dummies yValues: ( env versions collect: [:v|  v valueOf: m ]).
		combination add:(dummies buildDummies). ].
	historyObject colors: (hm collect: [ :m | m selector]).
	historyObject histories: combination.
	dummies := historyObject buildDummies.
	^dummies.! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:10'!
hotMethods: env
	^ env methods.! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:11'!
openOn: aRizelEnviroment
	""
	self browser openOn: aRizelEnviroment.! !

!RizelBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/7/2012 23:57'!
projects
	
	| dummies1 dummies2 dummies3 historyObject LOC1 LOC2 LOC3 combination LOC4 LOC5 LOC6 dummies4 dummies5 dummies6 |
	dummies1 := ESDummyFactory new.
	dummies2 := ESDummyFactory new.
	dummies3 := ESDummyFactory new.
	dummies4 := ESDummyFactory new.
	dummies5 := ESDummyFactory new.
	dummies6 := ESDummyFactory new.
	historyObject := ESDummyFactory new.
	LOC1 := #(1 2 3 4 5 6 7 8 10 10 10 10 10 10 10 10 7 8 10 10 10 12 13 13 14 19 10).
	LOC2 := #(13 12 11 10 10 11 12 12 12 14 9 10 11 12 11 16 15 14 13 16 15 14 10 10 15 20 30).
	LOC3 := #(16 15 14 13 12 15 15 16 18 19 18 10 11 11 12 13 14 12 10 5 3 2 1 1 0 0 0).
	LOC4 := #(1 1 1 2 3 4 4 4 4 3 4 2 3 4 3 5 8 15 19 20 14 15 18 12 14 13 14).
	LOC5 := #(13 12 11 10 10 11 16 15 14 12 10 10 12 13 14 14 19 21 22 23 24 25 35 40 45 50 60).
	LOC6 := #(1 2 3 4 2 3 3 2 2 3 2 1 2 3 4 2 1 5 6 8 10 12 13 15 12 12 12).
	dummies1 yValues: LOC1.
	dummies2 yValues: LOC2.
	dummies3 yValues: LOC3.
	dummies4 yValues: LOC4.
	dummies5 yValues: LOC5.
	dummies6 yValues: LOC6.
	combination := OrderedCollection new.
	combination add: dummies1 buildDummies.
	combination add: dummies2 buildDummies.
	combination add: dummies3 buildDummies.
	combination add: dummies4 buildDummies.
	combination add: dummies5 buildDummies.
	combination add: dummies6 buildDummies.
	historyObject colors: #('Alpha' 'Beta' 'Delta' 'Epsilon' 'Gamma' 'Zeta').
	historyObject histories: combination.
	^historyObject buildDummies! !

RizelBrowser subclass: #RizelGlobalBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelGlobalBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 14:13'!
browser
	""
	|browser|
	browser := GLMTabulator new.
	
	browser column: #eyesee   span: 10.
			
	browser transmit
		to: #eyesee;
		from: #outer port: #entity;
		andShow:[ :a | self eyeseeOn: a ].
	
	^ browser.
	! !

!RizelGlobalBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:06'!
eyeseeOn: presentation
	^ presentation eyesee
			when: [ :env | env notNil];
			diagram: [ :renderer :env|
					| diag |
					diag := (renderer lineDiagram).
					diag
						y: [: rv |  rv value.];
						identifier: #versionNumber;
						yAxisLabel: 'Time';
						height: 500;
						width: 2000;
						rotatedLabels: true;
						defaultColor: Color blue;
						models: (env versions);
						regularAxis. 
					diag].! !

RizelBrowser subclass: #RizelMethodBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelMethodBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/7/2012 23:13'!
browser
	""
	|browser|
	browser := GLMTabulator new.
	
	browser column: #methods span: 4;
	column: #eyesee   span: 10.
	
	browser transmit
		to: #methods;
		from: #outer port: #entity;
		andShow:[ :a | self methodsOn: a].
		
	browser transmit
		to: #eyesee;
		from: #outer port: #entity;
		from: #methods;
		andShow:[ :a | self eyeseeOn: a ].
	
	^ browser.
	! !

!RizelMethodBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/7/2012 23:13'!
eyeseeOn: presentation
	^ presentation eyesee
			when: [ :env :method | env notNil and: [ method notNil ]];
			diagram: [ :renderer :env :method|
					| diag |
					diag := (renderer lineDiagram).
					diag
						y: [: rv |  rv valueOf: method];
						identifier: #versionNumber;
						yAxisLabel: 'Time';
						height: 500;
						width: 1000;
						rotatedLabels: true;
						defaultColor: Color blue;
						models: (env versions);
						regularAxis. 
					diag].! !

!RizelMethodBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/7/2012 23:13'!
methodsOn: a
	^ a list
			useExplicitNotNil;
			when: [ :env | env notNil];
			display: [ :env | env methods];
			format: [ :spyMethod | (spyMethod classSpy className),'>>',(spyMethod selector) ].! !

Object subclass: #RizelEnviroment
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:46'!
addVersion: aMessageTail
	versions add: aMessageTail.! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:21'!
copyWithLast: number
	|newEnv|
	newEnv := RizelEnviroment new.
	newEnv versions: (self versions last: number).
	^ newEnv.! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: ''!
estEnviroment
	| t1 t2 t3 t4 t5 |
	t2 := MCHttpRepository
				location: 'http://www.squeaksource.com/EyeSee'
				user: ''
				password: ''.
	t3 := (t2
				versionNamesBetween: 80
				and: 85
				every: 1)
				select: [:t6 | '*Core*' match: t6].
	t1 := RizelEnviroment new.
	t3
		do: [:t6 | 
			| t7 t8 t9 |
			t7 := RizelVersionRunner repository: t2 version: t6.
			t8 := t7
						profile: [[ESExamples new historyDiagram3]
								on: Error
								do: []].
			t9 := RizelVersion new.
			t9 tally: t8;
				 versionNumber: t6.
			"t1 addVersion: t9"
			].
	self assert: t3 size = t1 versions size.
	^ t1! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:09'!
initialize
	super initialize.
	versions := OrderedCollection new.
! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandova 12/27/2011 18:38'!
methods
	^  versions last methods.! !

!RizelEnviroment methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:45'!
versions
	^ versions.! !

!RizelEnviroment methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
versions: anObject
	versions := anObject! !

Object subclass: #RizelRunner
	instanceVariableNames: 'tally pollingEvery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

RizelRunner subclass: #RizelBasicRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelBasicRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:39'!
profile: aBlock
	| stream list result |
	
	tally := MessageTally new.
	tally
		reportOtherProcesses: false;
		maxClassNameSize: 1000;
		maxClassPlusSelectorSize: 1000;
		maxTabs: 100.
	
	tally spyEvery: pollingEvery on: aBlock.
	^ tally.! !

!RizelRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 16:29'!
initialize 
	super initialize.
	pollingEvery := MessageTally defaultPollPeriod.
	! !

!RizelRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 16:26'!
pollingEvery: aPollingEvery
	pollingEvery:= aPollingEvery! !

!RizelRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:38'!
profile: aBlock
	! !

RizelRunner subclass: #RizelVersionRunner
	instanceVariableNames: 'version repository regexExp projectName configuration configName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

RizelVersionRunner subclass: #RizelCompteurRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelCompteurRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 12:45'!
profiler
	^ Compteur.! !

!RizelCompteurRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 14:12'!
valueBlock
	^ [ :model | model numberOfCalls ].! !

RizelVersionRunner subclass: #RizelHapaoRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelHapaoRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 16:37'!
generateBlock
	|testSuite testCases|
	testSuite := TestSuite new.
	TestCase allSubclasses select: [ : tc | ].
	! !

!RizelHapaoRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 12:58'!
profile
	|aBlock|
	aBlock := [].
	Gofer new repository: repository;
						 version: version;
						 load.
	^ (self profiler) profile:aBlock inPackagesMatching: regexExp.! !

!RizelHapaoRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 12:54'!
profiler
	^ HapaoTestCoverage.! !

!RizelHapaoRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 14:17'!
valueBlock
	^ [ :model | model coverage].! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 15:43'!
buildVersion: trace
	|rv|
	rv := RizelVersion new.
	rv trace: trace;
		versionNumber: (self version);
		value: (self valueBlock).
	^rv.! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 18:18'!
configName
	^ configName! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 18:18'!
configName: anObject
	configName := anObject! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 12:09'!
configSymbol
	^ configSymbol! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 12:09'!
configSymbol: anObject
	configSymbol := anObject! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 12:09'!
configuration
	^ configuration! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 12:09'!
configuration: anObject
	configuration := anObject! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 18:14'!
profile: aBlock
	|rv trace|
	"loading version"
	Gofer new 
			squeaksource: projectName;
			package: configName;
			load.
	configuration load.
	"get trace"
	trace := ((self profiler) profile:aBlock inPackagesMatching: regexExp).
	
	^ (self buildVersion: trace).
	! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 14:27'!
profiler
	^ self subclassResponsibility.! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 12:09'!
projectName
	^ projectName! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/6/2012 12:09'!
projectName: anObject
	projectName := anObject! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 12:48'!
regexExp
	^ regexExp! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 12:48'!
regexExp: anObject
	regexExp := anObject! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 12:48'!
repository
	^ repository! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:36'!
repository: aRepository
	repository := aRepository.! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 13:08'!
valueBlock
	^ self subclassResponsibility.! !

!RizelVersionRunner methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 12:53'!
version
	^ version! !

!RizelVersionRunner methodsFor: 'as yet unclassified' stamp: 'JSandoval 12/26/2011 17:36'!
version: aVersion
	version:= aVersion.! !

Object subclass: #RizelVersion
	instanceVariableNames: 'trace versionNumber valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel'!

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 02:02'!
methods
	|ms|
	ms := (trace allMethods asSortedCollection: [ :A :B |  B numberOfCalls > A numberOfCalls]).
	^ (ms size >10) ifTrue: [ ms last:10 ] ifFalse:[  ms ].
! !

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/1/2012 18:43'!
timeOf: aSpyMethod
	|shadowMethod res|
	shadowMethod := nil.
	res := 0.
	shadowMethod := trace allMethods select: [ : A | A selector = aSpyMethod selector].
	((shadowMethod notNil) and:[ shadowMethod size >0]) ifTrue: [
		shadowMethod := shadowMethod first.	
			res := shadowMethod numberOfCalls.
		].
	^ res / 1000.! !

!RizelVersion methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/1/2012 17:49'!
trace
	^ trace! !

!RizelVersion methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 1/1/2012 17:49'!
trace: anObject
	trace := anObject! !

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 16:28'!
value
	^ valueBlock value: trace.! !

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/5/2012 13:02'!
value: aBlock
	valueBlock := aBlock.! !

!RizelVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 1/8/2012 01:29'!
valueOf: aSpyMethod
	|shadowMethod res|
	shadowMethod := nil.
	res := 0.
	shadowMethod := trace allMethods select: [ : A | A selector = aSpyMethod selector].
	((shadowMethod notNil) and:[ shadowMethod size >0]) ifTrue: [
		shadowMethod := shadowMethod first.	
			res := valueBlock value: shadowMethod.
		].
	^ res/ (valueBlock value: trace).! !

!RizelVersion methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
versionNumber
	^ versionNumber! !

!RizelVersion methodsFor: 'accessing' stamp: 'JSandoval 12/26/2011 17:48'!
versionNumber: anObject
	versionNumber := anObject! !
